(defun bug-23917-after-modhook (beg end length)
  (message "match-data-post1: %S" (mapcar #'marker-position (match-data)))
  (save-match-data
    nil)
  (message "match-data-post2: %S" (mapcar #'marker-position (match-data))))

(defun bug-23917-before-modhook (beg end)
  (message "match-data-pre-1: %S" (mapcar #'marker-position (match-data)))
  (save-match-data
    nil)
  (message "match-data-pre-2: %S" (mapcar #'marker-position (match-data))))

(defun bug-23917-doit ()
  (interactive)
  (with-current-buffer (get-buffer-create "*bug 23917*")
    (switch-to-buffer (current-buffer))
    (erase-buffer)
    (insert "xxxxxxxxx yyyyyyyyy zzzzzzzzz")
    (goto-char 1)
    (re-search-forward "\\(x+\\) \\(y+\\) \\(z+\\)")
    (let ((after-change-functions '(bug-23917-after-modhook))
          (before-change-functions '(bug-23917-before-modhook)))
      (replace-match "3" t t nil 3))
    (view-echo-area-messages)))

(bug-23917-doit)
